//---------------------------------------------------------
// i8091 header file                      
//
// v1.0 6/20/2001
//---------------------------------------------------------  
#define CALLBACK
#define EXPORTS extern
                         
#define i8091        0x0e                         
                         
#define YES          1
#define NO           0

#define READY        0
#define BUSY         1
  
#define ON           1
#define OFF          0

#define CW_CCW       0
#define PULSE_DIR    1

#define NORMAL_DIR   0
#define REVERSE_DIR  1

#define FW           0
#define BW           1
#define CW           0
#define CCW          1
#define X_axis       1
#define Y_axis       2 
#define Z_axis       3            

//------------Setting Command------------------------------------------------
EXPORTS unsigned char CALLBACK i8091_REGISTRATION(unsigned char cardNo,
                                                   unsigned int address);
EXPORTS unsigned char CALLBACK i8091_LIMIT_X(unsigned char cardNo);
EXPORTS unsigned char CALLBACK i8091_LIMIT_Y(unsigned char cardNo);
//----------------------------------------------------
EXPORTS void          CALLBACK i8091_WAIT_X(unsigned char cardNo);
EXPORTS unsigned char CALLBACK i8091_IS_X_STOP(unsigned char cardNo);
EXPORTS void          CALLBACK i8091_WAIT_Y(unsigned char cardNo);
EXPORTS unsigned char CALLBACK i8091_IS_Y_STOP(unsigned char cardNo);
//----------------------------------------------------
EXPORTS void CALLBACK i8091_SET_VAR(unsigned char cardNo,
                            unsigned char set_DDA_cycle,
                            unsigned char set_Acc_Dec,
                            unsigned int set_Low_Speed,
                            unsigned int set_High_Speed);
EXPORTS void CALLBACK i8091_SET_DEFDIR(unsigned char cardNo,
                               unsigned char defdirX,
                               unsigned char defdirY);
EXPORTS void CALLBACK i8091_SET_MODE(unsigned char cardNo,
                             unsigned char modeX,
                             unsigned char modeY);
EXPORTS void CALLBACK i8091_SET_SERVO_ON(unsigned char cardNo,
                                 unsigned char sonX,
                                 unsigned char sonY);
EXPORTS void CALLBACK i8091_SET_NC(unsigned char cardNo, unsigned char sw);
//----------------------------------------------------
EXPORTS void CALLBACK i8091_STOP_X(unsigned char cardNo);
EXPORTS void CALLBACK i8091_STOP_Y(unsigned char cardNo);
EXPORTS void CALLBACK i8091_RESET_SYSTEM(unsigned char cardNo); 
EXPORTS void CALLBACK i8091_STOP_ALL(unsigned char cardNo);
EXPORTS void CALLBACK i8091_EMG_STOP(unsigned char cardNo);
//----------------------------------------------------
EXPORTS void CALLBACK i8091_LSP_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
EXPORTS void CALLBACK i8091_HSP_ORG(unsigned char cardNo,
                            unsigned char DIR,
                            unsigned char AXIS);
EXPORTS void CALLBACK i8091_LSP_PULSE_MOVE(unsigned char cardNo,
                                   unsigned char AXIS,
                                   long pulseN);
EXPORTS void CALLBACK i8091_HSP_PULSE_MOVE(unsigned char cardNo,
                                   unsigned char AXIS,
				   long pulseN,
				   unsigned int speed);
EXPORTS void CALLBACK i8091_LSP_MOVE(unsigned char cardNo,
			     unsigned char DIR,
			     unsigned char AXIS);
EXPORTS void CALLBACK i8091_HSP_MOVE(unsigned char cardNo,
			     unsigned char DIR,
			     unsigned char AXIS);
EXPORTS void CALLBACK i8091_CSP_MOVE(unsigned char cardNo,
			     unsigned char DIR,
			     unsigned char AXIS,
                             unsigned int  move_speed);
EXPORTS void CALLBACK i8091_SLOW_DOWN(unsigned char cardNo,
                              unsigned char AXIS);
EXPORTS void CALLBACK i8091_SLOW_STOP(unsigned char cardNo,
                              unsigned char AXIS);           
//------------------------------------------------------------------------                              
EXPORTS void CALLBACK i8091_INTP_PULSE(unsigned char cardNo,
                               int Xpulse, int Ypulse);
EXPORTS void CALLBACK i8091_INTP_LINE(unsigned char cardNo,
                              long Xpulse, long Ypulse);
//------------------------------------------------------------------------
EXPORTS void CALLBACK i8091_INTP_LINE02(unsigned char cardNo,
                                 long x,long y,
                                 unsigned int speed,
                                 unsigned char acc_mode);
EXPORTS void CALLBACK i8091_INTP_CIRCLE02(unsigned char cardNo,
                           long x,
                           long y,
                           unsigned char dir,
                           unsigned int speed,
                           unsigned char acc_mode);
EXPORTS void CALLBACK i8091_INTP_ARC02(unsigned char cardNo,
                        long x,
                        long y,
                        long R,
                        unsigned char dir,
                        unsigned int speed,
                        unsigned char acc_mode);
EXPORTS unsigned char CALLBACK i8091_INTP_STOP();

