typedef unsigned int  uint;
//typedef unsigned int  WORD;
typedef unsigned char uchar;
typedef unsigned char BYTE;
typedef unsigned long ulong;
typedef unsigned long DWORD;

#ifdef __TURBOC__
  #if (__TURBOC__ < 0x0300)
/*    #define inp    inportb */
    #define inpw   inport
/*    #define outp   outportb */
    #define outpw  outport
  #endif
#endif

#define BUF_SIZE     1024   /* must be 2 ** n */
#define IN_BUF_SIZE  1024
#define OUT_BUF_SIZE 1024

#define    NoError	    0
#define    InitPinIsOpen    0
#define    InitPinIsNotopen 1
#define    QueueIsEmpty     0
#define    QueueIsNotEmpty  1
#define    PortError	   -1
#define    DataError	   -2
#define    ParityError	   -3
#define    StopError	   -4
#define    TimeOut	   -5
#define    QueueEmpty	   -6
#define    QueueOverflow   -7
#define    PosError	   -8
#define    AddrError	   -9
#define    BlockError	   -10
#define    WriteError	   -11
#define    SegmentError    -12
#define    BaudRateError   -13
#define    CheckSumError   -14
#define    ChannelError    -15
#define    BaudrateError   -16
#define    TriggerLevelError   -17
#define    DateError    -18
#define    TimeError    -19
#define    TimeIsUp        1

extern char hex_to_ascii[16];

#ifdef __cplusplus
extern "C" {
#endif

/*
 Functions for COM2
*/
#define InstallCom2	InstallCom_2
#define RestoreCom2	RestoreCom_2
#define IsCom2		IsCom_2
#define ToCom2		ToCom_2
#define ToCom2Str	ToComStr_2
#define ToCom2Bufn	ToComBufn_2
#define printCom2	printCom_2
#define ClearTxBuffer2	ClearTxBuffer_2
#define SetCom2FifoTriggerLevel		SetComFifoTriggerLevel_2
#define SetBaudrate2	SetBaudrate_2
#define ReadCom2	ReadCom_2
#define ClearCom2	ClearCom_2
#define DataSizeInCom2  DataSizeInCom_2
#define WaitTransmitOver2	WaitTransmitOver_2
#define IsTxBufEmpty2		IsTxBufEmpty_2
#define IsCom2OutBufEmpty	IsComOutBufEmpty_2
#define ReadCom2n		ReadComn_2
#define SetDataFormat2		SetDataFormat_2
#define SetRtsActive2		SetRtsActive_2
#define SetRtsInactive2		SetRtsInactive_2
#define GetCtsStatus2		GetCtsStatus_2

int InstallCom_2(unsigned long baud, int data, int parity, int stop);
int RestoreCom_2(void);
int IsCom_2(void);
int ToCom_2(int data);
int ToComStr_2(char *str);
int ToComBufn_2(char *buf,int no);
int printCom_2(char *fmt,...);
void ClearTxBuffer_2(void);
int SetComFifoTriggerLevel_2(int level);
int SetBaudrate_2(unsigned long baud);
int ReadCom_2(void);
int ClearCom_2(void);
int DataSizeInCom_2(void);
int WaitTransmitOver_2(void);
int IsTxBufEmpty_2(void);
int IsComOutBufEmpty_2(void);
int SetDataFormat_2(int databit,int parity,int stopbit);
int ReadComn_2(unsigned char *buf,int n);
void SetRtsActive_2(void);
void SetRtsInactive_2(void);
int GetCtsStatus_2(void);

/*
 Functions for COM3
*/
#define InstallCom3	InstallCom_3
#define RestoreCom3	RestoreCom_3
#define IsCom3		IsCom_3
#define ToCom3		ToCom_3
#define ToCom3Str	ToComStr_3
#define ToCom3Bufn	ToComBufn_3
#define printCom3	printCom_3
#define ClearTxBuffer3	ClearTxBuffer_3
#define SetCom3FifoTriggerLevel		SetComFifoTriggerLevel_3
#define SetBaudrate3	SetBaudrate_3
#define ReadCom3	ReadCom_3
#define ClearCom3	ClearCom_3
#define DataSizeInCom3  DataSizeInCom_3
#define WaitTransmitOver3	WaitTransmitOver_3
#define IsTxBufEmpty3		IsTxBufEmpty_3
#define IsCom3OutBufEmpty	IsComOutBufEmpty_3
#define ReadCom3n		ReadComn_3
#define SetDataFormat3		SetDataFormat_3
#define SetRtsActive3		SetRtsActive_3
#define SetRtsInactive3		SetRtsInactive_3
#define GetCtsStatus3		GetCtsStatus_3

int InstallCom_3(unsigned long baud, int data, int parity, int stop);
int RestoreCom_3(void);
int IsCom_3(void);
int ToCom_3(int data);
int ToComStr_3(char *str);
int ToComBufn_3(char *buf,int no);
int printCom_3(char *fmt,...);
void ClearTxBuffer_3(void);
int SetComFifoTriggerLevel_3(int level);
int SetBaudrate_3(unsigned long baud);
int ReadCom_3(void);
int ClearCom_3(void);
int DataSizeInCom_3(void);
int WaitTransmitOver_3(void);
int IsTxBufEmpty_3(void);
int IsComOutBufEmpty_3(void);
int SetDataFormat_3(int databit,int parity,int stopbit);
int ReadComn_3(unsigned char *buf,int n);
void SetRtsActive_3(void);
void SetRtsInactive_3(void);
int GetCtsStatus_3(void);

/*
 Functions for COM4
*/
#define InstallCom4	InstallCom_4
#define RestoreCom4	RestoreCom_4
#define IsCom4		IsCom_4
#define ToCom4		ToCom_4
#define ToCom4Str	ToComStr_4
#define ToCom4Bufn	ToComBufn_4
#define printCom4	printCom_4
#define ClearTxBuffer4	ClearTxBuffer_4
#define SetCom4FifoTriggerLevel		SetComFifoTriggerLevel_4
#define SetBaudrate4	SetBaudrate_4
#define ReadCom4	ReadCom_4
#define ClearCom4	ClearCom_4
#define DataSizeInCom4  DataSizeInCom_4
#define WaitTransmitOver4	WaitTransmitOver_4
#define IsTxBufEmpty4		IsTxBufEmpty_4
#define IsCom4OutBufEmpty	IsComOutBufEmpty_4
#define ReadCom4n		ReadComn_4
#define SetDataFormat4		SetDataFormat_4
#define SetRtsActive4		SetRtsActive_4
#define SetRtsInactive4		SetRtsInactive_4
#define GetCtsStatus4		GetCtsStatus_4

int InstallCom_4(unsigned long baud, int data, int parity, int stop);
int RestoreCom_4(void);
int IsCom_4(void);
int ToCom_4(int data);
int ToComStr_4(char *str);
int ToComBufn_4(char *buf,int no);
int printCom_4(char *fmt,...);
void ClearTxBuffer_4(void);
int SetComFifoTriggerLevel_4(int level);
int SetBaudrate_4(unsigned long baud);
int ReadCom_4(void);
int ClearCom_4(void);
int DataSizeInCom_4(void);
int WaitTransmitOver_4(void);
int IsTxBufEmpty_4(void);
int IsComOutBufEmpty_4(void);
int SetDataFormat_4(int databit,int parity,int stopbit);
int ReadComn_4(unsigned char *buf,int n);
void SetRtsActive_4(void);
void SetRtsInactive_4(void);
int GetCtsStatus_4(void);

void InitLib(void);
int GetComportNumber(void);
int  InstallCom(int port, unsigned long baud, int data, int parity,int stop);
int  InstallCom0(unsigned long baud, int data, int parity);
int  InstallCom1(unsigned long baud, int data, int parity);
/*
int  InstallCom2(unsigned long baud, int data, int parity,int stop);
int  InstallCom3(unsigned long baud, int data, int parity,int stop);
int  InstallCom4(unsigned long baud, int data, int parity,int stop);
*/
int  RestoreCom(int port);
int  RestoreCom0(void);
int  RestoreCom1(void);
/*
int  RestoreCom2(void);
int  RestoreCom3(void);
int  RestoreCom4(void);
*/
int  IsCom(int port);
int  IsCom0(void);
int  IsCom1(void);
/*
int  IsCom2(void);
int  IsCom3(void);
int  IsCom4(void);
*/
int  ReadCom(int port);
int  ReadCom0(void);
int  ReadCom1(void);
/*
int  ReadCom2(void);
int  ReadCom3(void);
int  ReadCom4(void);
*/
int  ToCom(int port, int data);
int  ToCom0(int data);
int  ToCom1(int data);
/*
int  ToCom2(int data);
int  ToCom3(int data);
int  ToCom4(int data);
*/
int ToComBufn(int port,char *buf,int no);
int ToCom0Bufn(char *buf,int no);
int ToCom1Bufn(char *buf,int no);
/*
int ToCom2Bufn(char *buf,int no);
int ToCom3Bufn(char *buf,int no);
int ToCom4Bufn(char *buf,int no);
*/
int  ToComStr(int port, char *str);
int  ToCom0Str(char *str);
int  ToCom1Str(char *str);
/*
int  ToCom2Str(char *str);
int  ToCom3Str(char *str);
int  ToCom4Str(char *str);
*/
int  ClearCom(int port);
int  ClearCom0(void);
int  ClearCom1(void);
/*
int  ClearCom2(void);
int  ClearCom3(void);
int  ClearCom4(void);
*/
int  WaitTransmitOver(int port);
int  WaitTransmitOver0(void);
int  WaitTransmitOver1(void);
/*
int  WaitTransmitOver2(void);
int  WaitTransmitOver3(void);
int  WaitTransmitOver4(void);
*/
int  ReadInitPin(void);
void Init5DigitLed(void);
int  Show5DigitLed(int position, int value);
int  Show5DigitLedSeg(int pos, unsigned char data);
void DelayTimeMs(unsigned int time);

int  WriteEEP(int block, int addr, int data);
int  ReadEEP(int block, int addr);
void EnableEEP(void);
void ProtectEEP(void);

void EnableWDT(void);
void RefreshWDT(void);
void DisableWDT(void);

int FlashReadId(void);
int FlashWrite(unsigned int seg, unsigned int offset, char data);
int FlashErase(unsigned int seg);
int FlashRead(unsigned int seg, unsigned int offset);

void Delay(unsigned ms);
void Delay_1(unsigned ms);

int Is8000(void);
int Getch(void);
int Kbhit(void);
int Ungetch(int key);
void Putch(int data);
int Puts(char *str);
int Print(char *fmt,...);

int ascii_to_hex(char ascii);
int SendCmdTo7000(int iPort, unsigned char *cCmd, int iChksum);
int ReceiveResponseFrom7000(int iPort, unsigned char *cCmd, long lTimeout, int iChksum);

/*void far *_MK_FP(unsigned segment,unsigned offset);*/
int IsResetByWatchDogTimer(void);
int IsResetByPowerOff(void); /* for bios date 12/12/98 or later */

int Show5DigitLedWithDot(int pos, int data);
void Set5DigitLedTestMode(int mode);
void Set5DigitLedIntensity(int mode);
void Disable5DigitLed(void);
void Enable5DigitLed(void);
unsigned GetLibVersion(void);

/* 01/07/1999  Add Timer function */
int TimerOpen(void);
int TimerClose(void);
void TimerResetValue(void);
unsigned long TimerReadValue(void);
void DelayMs(unsigned t);
int StopWatchReset(int channel);
int StopWatchStart(int channel);
int StopWatchStop(int channel);
int StopWatchPause(int channel);
int StopWatchContinue(int channel);
int StopWatchReadValue(int channel,unsigned long *value);
int CountDownTimerStart(int channel,unsigned long count);
int CountDownTimerReadValue(int channel,unsigned long *value);
void InstallUserTimer(void (*fun)(void));
void InstallUserTimer1C(void (*fun)(void));
int DataSizeInCom(int port);
int DataSizeInCom0(void);
int DataSizeInCom1(void);
/*
int DataSizeInCom2(void);
int DataSizeInCom3(void);
int DataSizeInCom4(void);
*/
int SetCom2FifoTriggerLevel(int level);

/* New for Ver 1.13 */
/* 07-23-1999 add 4 function for COM1 /DTR,/RTS output pins */
void SetRtsActive(void);
void SetRtsInactive(void);

/* [New for Ver 1.14] */
/**** 07/27/1999 add 5 function for COM1/2/3/4 formated output ****/
int printCom(int port,char *fmt,...);
int printCom0(char *fmt,...);
int printCom1(char *fmt,...);
/*
int printCom2(char *fmt,...);
int printCom3(char *fmt,...);
int printCom4(char *fmt,...);
*/
/* 08/06/1999 add 2 function for COM1 CTS,DSR input pins */
int GetCtsStatus(void);

/* 08/25/1999 add 5 function for COM1-4 */
int IsTxBufEmpty(int port);
int IsTxBufEmpty0(void);
int IsTxBufEmpty1(void);
/*
int IsTxBufEmpty2(void);
int IsTxBufEmpty3(void);
int IsTxBufEmpty4(void);
*/
/* 10/19/1999 add 5 function for COM1/2/3/4 change baudrate */
int SetBaudrate(int port,unsigned long baud);
int SetBaudrate0(unsigned long baud);
int SetBaudrate1(unsigned long baud);
/*
int SetBaudrate2(unsigned long baud);
int SetBaudrate3(unsigned long baud);
int SetBaudrate4(unsigned long baud);
*/
/* 10/20/1999 */
/* (1) add 10 function for COM1/2/3/4 send/detect BREAK signal */
int SendBreak(int port,unsigned timems);
void SendBreak0(unsigned timems);
void SendBreak1(unsigned timems);
void SendBreak2(unsigned timems);
int IsDetectBreak(int port);
int IsDetectBreak0(void);
int IsDetectBreak1(void);
int IsDetectBreak2(void);
int IsDetectBreak3(void);
int IsDetectBreak4(void);

/* (2) Add 3 functions for clear COM1/2/3/4 output buffer */
int ClearTxBuffer(int port);
void ClearTxBuffer0(void);
void ClearTxBuffer1(void);
/*
void ClearTxBuffer2(void);
void ClearTxBuffer3(void);
void ClearTxBuffer4(void);
*/

#ifndef __FILE_DATA__
#define __FILE_DATA__
typedef struct  {
  unsigned mark;   /* 0x7188 -> is file */
  unsigned char fname[12];
  unsigned char year;
  unsigned char month;
  unsigned char day;
  unsigned char hour;
  unsigned char minute;
  unsigned char sec;
  unsigned long size;
  char far *addr;
  unsigned CRC;
  unsigned CRC32;
} FILE_DATA;
#endif

/* 12/29/1999 */
/*
  Add functions for ReadOnly file system of 7188R/7188X
*/
int GetFileNo(void);
int GetFileName(int no,char *fname);
char far *GetFilePositionByNo(int no);
char far *GetFilePositionByName(char *fname);
FILE_DATA far *GetFileInfoByNo(int no);           /* 04/11/2000 */
FILE_DATA far *GetFileInfoByName(char *fname);    /* 04/11/2000 */

/*
 02/17/2000
 Add functions for LED RUN/BATT/COMM
 12/06/2000 Rename these function with the final name L1/L2/L3
*/
/*
void LedBattOn(void);
void LedBattOff(void);
void LedCommOn(void);
void LedCommOff(void);
void LedRunOn(void);
void LedRunOff(void);
*/
#define LED_OFF     0
#define LED_ON      1
#define LED_TOGGLE  2

#define LedBattOn()   SetLedL3(LED_ON)
#define LedBattOff()  SetLedL3(LED_OFF)
#define LedCommOn()   SetLedL2(LED_ON)
#define LedCommOff()  SetLedL2(LED_OFF)
#define LedRunOn()    SetLedL1(LED_ON)
#define LedRunOff()   SetLedL1(LED_OFF)


/*
 02/21/2000
 Add functions for SystemKey (UP,DOWN,MODE,SET)
 05/08/2001
 Change the definition of SKEY_DOWN & SKEY_UP & SKEY_MODE
*/
#define SKEY_SET    1
#define SKEY_DOWN   2
#define SKEY_MODE   3
#define SKEY_UP     4

int IsSystemKey(void);
int GetSystemKey(void);
void ClearSystemKey(void);

/*
 03/15/2000
 Add function Scanf ...
*/
int LineInput(char *buf,int maxlen); /* input one line from StdInput */
void ResetScanBuffer(void); /* Set Scanf to use default buffer(maxlen=80) */
void SetScanBuffer(unsigned char *buf,int len); /* Set user's buffer for Scanf */
int Scanf(char *fmt, ...); /* like C's scanf */

/*
06/01/2000
 Add functions for RTC/NVRAM
*/
void ReadRTC(int addr, int *data);
void WriteRTC(int addr, int data);
int ReadNVRAM(int addr);
int WriteNVRAM(int addr, int data);
void GetDate(int *year,int *month,int *day);
void GetTime(int *hour,int *minute,int *sec);
int SetDate(int year,int month,int day);
int SetTime(int hour,int minute,int sec);

/*
07/31/2000
  Add functions for Change Slot,and address bus A9,A12,B1A5,B1A6
*/
void ChangeToSlot(int slot);  /* slot=0,1,2,3,4,5,6,7 */
void SetA9(int mode);         /* mode: 0-> low , 1-> high */
void SetA12(int mode);        /* mode: 0-> low , 1-> high */
void SetB1A5(int mode);       /* mode: 0-> low , 1-> high */
void SetB1A6(int mode);       /* mode: 0-> low , 1-> high */
int GetNetId(void);           /* range 0-255 */

/*
08/01/2000
  Add functions for Set/Read weekday
*/
int GetWeekDay(void);     /* 0-6, 0:Sun., 1:Mon., ... 6:Sat.*/
void SetWeekDay(int day);

/*
 10/16/2000  start Ver 1.17
 Add new EEPROM functions
*/
void EE_WriteEnable(void);
void EE_WriteProtect(void);
int EE_RandomRead(int Block,int Addr);
int EE_ReadNext(int Block);
int EE_MultiRead(int StartBlock,int StartAddr,int no,char *databuf);
int EE_RandomWrite(int Block,int Addr,int Data);
int EE_MultiWrite(int Block,int Addr,int no,char *Data);

/*
11/03/2000
  Add function for 8000 series cards
*/
extern unsigned char far * const ModuleType;
extern unsigned char far * const NameOfModule;
void ShowLED16(int slot ,unsigned data); /* used for DO16 */
void ShowLED8(int slot ,unsigned char data); /* used for DI8DO8 's DO8 */
int GetNumberOfSlot(void); /* return 4 or 8 */


/*
12/04/2000
  Add function for 8000 , parallel DIO cards
*/
typedef union {
  struct {
   unsigned char do8,di8;
  } data8;
  unsigned      data16;
} DIODATA;
extern int SlotAddr[8];
//extern DIODATA far *DIOData; // [90/12/12]

void DO_16(int slot,unsigned int cdata); /* For 16 bits output */
void DO_8(int slot,unsigned char cdata); /* For 8 bits output */
void DIO_DO_8(int slot,unsigned char cdata); /* For 8 bits output on DI8/DO8*/
unsigned int DI_16(int slot); /* For 16 bits input */
unsigned char DI_8(int slot); /* For 8 bits input */


/*
12/06/2000
  Add function for 8000, LED_L1,LED_L2,LED_L3

*/
void SetLedL1(int mode); /* mode can be LED_OFF, LED_ON ,LED_TOGGLE */
void SetLedL2(int mode);
void SetLedL3(int mode);

/*
12/07/2000
  Add function for 8000, slot 4-7 interrupt signal
*/
void ClrSlotInt(int slot);
int GetSlotInt(void);

/*
01/11/2001
  Add variable for system serial number.
*/
extern unsigned char far * const SystemSerialNumber;

/*
05/09/2001
  Add for system key status.
*/
extern unsigned char far * const KeyStatus;
#define SKEY_SET_DOWN   0x08
#define SKEY_DOWN_DOWN  0x04
#define SKEY_UP_DOWN    0x02
#define SKEY_MODE_DOWN  0x01

/*
 05/18/2001 Ver 1.17
 Add new functions for IP address,EthernetAddress...
*/
void GetIp(unsigned char *ip);        /* IP address 4 bytes */
void GetEid(unsigned char *id);       /* Ethernet hardware address 6 bytes */
void GetMask(unsigned char *mask);    /* address mask 4 bytes */
void GetGateway(unsigned char *gate); /* gateway address mask 4 bytes */
void SetIp(unsigned char *ip);        /* IP address 4 bytes */
void SetEid(unsigned char *id);       /* Ethernet hardware address 6 bytes */
void SetMask(unsigned char *mask);    /* address mask 4 bytes */
void SetGateway(unsigned char *gate); /* gateway address mask 4 bytes */


/*
 09/06/2001 Ver 1.17
 Add 2 function for signal A5/A6

 If in ISR must cgange A5/A6 status, must use :

 int a5a6=GetB1A5A6();
 ...
 ...
 RestoreB1A5A6(a5a6);
*/
int GetB1A5A6(void);
void RestoreB1A5A6(int a5a6);
void SetB1A5A6(int mode);
/*
 mode: bit0-->A5, Bit1-->A6
*/

/*
 08/01/2001
 Add new timer functions
*/
/* for StopWatch [pɽX] */
#ifndef _T_STOPWATCH_
#define _T_STOPWATCH_
typedef struct {
 ulong ulStart,ulPauseTime;
 uint  uMode;  /* 0: pause, 1:run(start) */
} STOPWATCH;
#endif

void T_StopWatchStart(STOPWATCH *sw);
ulong T_StopWatchGetTime(STOPWATCH *sw);
void T_StopWatchPause(STOPWATCH *sw);
void T_StopWatchContinue(STOPWATCH *sw);

/* For CountDown Timer[˼ƭp] */
#ifndef _T_COUNTDOWNTIMER_
#define _T_COUNTDOWNTIMER_
typedef struct {
 ulong ulTime,ulStartTime,ulPauseTime;
 uint  uMode;  /* 0: pause, 1:run(start) */
} COUNTDOWNTIMER;
#endif

void T_CountDownTimerStart(COUNTDOWNTIMER *cdt,ulong timems);
void T_CountDownTimerPause(COUNTDOWNTIMER *cdt);
void T_CountDownTimerContinue(COUNTDOWNTIMER *cdt);
int T_CountDownTimerIsTimeUp(COUNTDOWNTIMER *cdt);
ulong T_CountDownTimerGetTimeLeft(COUNTDOWNTIMER *cdt);

extern const unsigned long far * const TimeTicks;
/* Variable: TimeTicks

   For read the system TimeTicks. (unit is ms)
*/


/*
 10/25/2001
 Add new COM1 functions
*/
int ReadCom1n(unsigned char *buf,int no);

/*
 03/19/2002
 Add function for TI0/TO0/TI1/TO1

 dir=0 : output mode
     1 : Input With pull up(or pull down)[TO0/TO1 are pull down],[TI0/TI1 are pull up]
     2 : set to Input Without pull up
     3 : set to Normal mode(used as AS TI0/TO0/TI1/TO1)
*/
void SetTi1Dir(int dir);
void SetTi1High(void);
void SetTi1Low(void);
int GetTi1(void);
void SetTo1Dir(int dir);
void SetTo1High(void);
void SetTo1Low(void);
int GetTo1(void);
void SetTi0Dir(int dir);
void SetTi0High(void);
void SetTi0Low(void);
int GetTi0(void);
void SetTo0Dir(int dir);
void SetTo0High(void);
void SetTo0Low(void);
int GetTo0(void);

/*
 04/03/2002
 Add function for 32*DO/32*DI/16DI_16DO (8040/8041/8042)
*/
typedef union {
  DIODATA data;
  struct {
   unsigned do16,di16;
  } data16;
  unsigned long  data32;
} DIODATA32;
extern DIODATA32 far *DIOData32;
void DO_32(int slot,unsigned long cdata);
void DIO_DO_16(int slot,unsigned cdata);
unsigned long int DI_32(int slot);

/*
 04/23/2002
 Add function for COM port on 8142/8144/8112/8114)
*/
int SetInBufSIze(int size);
int SetOutBufSIze(int size);
int _SetBaudrate(int slot,int port,unsigned long baud);
int _SetDataFormat(int slot,int port,int data, int parity,int stop);
int RestoreCom8000(int slot);
int InstallCom8000(int slot);
int IsCom8000(int slot,int port);
int ToCom8000(int slot,int port,int data);
int ToCom8000Str(int slot,int port,char *str);
int ToCom8000nBytes(int slot,int port,char *buf,int no);
int ReadCom8000(int slot,int port);
int ReadCom8000nBytes(int slot,int port,char *buf,int maxno);
int ClearCom8000(int slot, int port);

/*
 04/24/2002
 Add function for COM0 use DMA to send/receive data.
*/
unsigned Com0GetDataSize(void);
void Com0SetInputBuf(char far *ptr,unsigned cnt);
void Com0SendCmd(char far *cmd,unsigned length);
void OpenCom0UseDMA(void);
void CloseCom0UseDMA(void);
/* refer to "COM0DMA.txt" */

/* 11/07/2002 Add one function fo rget library release date. */
void GetLibDate(char *date);

/* 11/07/2002 add functions for DISK A/B (for OS Ver. 1.02.003[08/27/2002] or later)*/

typedef struct {
  unsigned sizeA:3;
  unsigned sizeB:3;
  unsigned sizeC:3;
  unsigned sum:7;
} SIZE_AB;

extern FILE_DATA far *fdata;
extern int FlashSize;
extern unsigned DiskAStartSeg,DiskBStartSeg;
extern SIZE_AB SizeAB;

void far *AddFarPtrLong(void far * ptr1,unsigned long size);
int GetFlashSize(void);

void ReadSizeAB(void);
int GetFileNo_AB(int disk);
int GetFileName_AB(int disk,int no,char *fname);
char far *GetFilePositionByNo_AB(int disk,int no);
char far *GetFilePositionByName_AB(int disk,char *fname);
FILE_DATA far *GetFileInfoByNo_AB(int disk,int no);           /* 04/11/2000 */
FILE_DATA far *GetFileInfoByName_AB(int disk,char *fname);    /* 04/11/2000 */
/*
[input]
 disk: 1 for disk B, others for disk A.
*/

/*
 [11/14/2002] add
*/
extern int TriggerLevel[8]; // define in COM1ISR.c
#define	COM1	0
#define	COM2	1
#define	COM3	2
#define	COM4	3

#define FLOW_CONTROL_DISABLE	0
#define FLOW_CONTROL_ENABLE	1
#define FLOW_CONTROL_AUTO_BY_HW 2
#define FLOW_CONTROL_AUTO_BY_SW	3


int GetTxBufferFreeSize(int port);
int GetTxBufferFreeSize_0(void);
int GetTxBufferFreeSize_1(void);
int GetTxBufferFreeSize_2(void);
int GetTxBufferFreeSize_3(void);
int GetTxBufferFreeSize_4(void);

/*
 [11/15/2002] add
*/
int SetBreakMode(int port,int mode);
void SetBreakMode_1(int mode);
void SetBreakMode_2(int mode);
void SetBreakMode_3(int mode);
void SetBreakMode_4(int mode);

/*
 [04/25/2003] add
*/
int SetDataFormat(int port,int databit,int parity,int stopbit);
/*
  port=0,1,2,3,4
*/
int SetDataFormat0(int databit,int parity,int stopbit);
int SetDataFormat1(int databit,int parity,int stopbit);
/*
  databit: 6,7
  parity:0:none,1:even,2:odd
  stopbit: always 1
*/
#ifdef __cplusplus
 }
#endif
